/* MainWindow.c generated by valac 0.43.6, the Vala compiler
 * generated from MainWindow.vala, do not modify */

/*
* Copyright (c) 2017 Daniel Foré (http://danielfore.com)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>

#define TYPE_MAIN_WINDOW (main_window_get_type ())
#define MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MAIN_WINDOW, MainWindow))
#define MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MAIN_WINDOW, MainWindowClass))
#define IS_MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MAIN_WINDOW))
#define IS_MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MAIN_WINDOW))
#define MAIN_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MAIN_WINDOW, MainWindowClass))

typedef struct _MainWindow MainWindow;
typedef struct _MainWindowClass MainWindowClass;
typedef struct _MainWindowPrivate MainWindowPrivate;

#define TYPE_GRADE_LABEL (grade_label_get_type ())
#define GRADE_LABEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GRADE_LABEL, GradeLabel))
#define GRADE_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GRADE_LABEL, GradeLabelClass))
#define IS_GRADE_LABEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GRADE_LABEL))
#define IS_GRADE_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GRADE_LABEL))
#define GRADE_LABEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GRADE_LABEL, GradeLabelClass))

typedef struct _GradeLabel GradeLabel;
typedef struct _GradeLabelClass GradeLabelClass;
enum  {
	MAIN_WINDOW_0_PROPERTY,
	MAIN_WINDOW_NUM_PROPERTIES
};
static GParamSpec* main_window_properties[MAIN_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block2Data Block2Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _MainWindow {
	GtkWindow parent_instance;
	MainWindowPrivate * priv;
};

struct _MainWindowClass {
	GtkWindowClass parent_class;
};

struct _MainWindowPrivate {
	GdkRGBA gdk_color;
	GtkEntry* bg_entry;
	GtkEntry* fg_entry;
	GtkLabel* results_label;
	GradeLabel* a_level;
	GradeLabel* aa_level;
	GradeLabel* aaa_level;
	gchar* prev_foreground_entry;
	gchar* prev_background_entry;
};

struct _Block2Data {
	int _ref_count_;
	MainWindow* self;
	GtkColorSelection* widget;
	GtkEntry* entry;
};

static gint MainWindow_private_offset;
static gpointer main_window_parent_class = NULL;
extern GSettings* harvey_settings;

GType main_window_get_type (void) G_GNUC_CONST;
GType grade_label_get_type (void) G_GNUC_CONST;
#define MAIN_WINDOW_RESULTS_CSS "\n" \
"        @define-color colorForeground %s;\n" \
"        @define-color colorBackground %s;\n" \
"\n" \
"        .output-header,\n" \
"        .results {\n" \
"            transition: all 250ms ease-in-out;\n" \
"        }\n" \
"    "
MainWindow* main_window_new (GtkApplication* application);
MainWindow* main_window_construct (GType object_type,
                                   GtkApplication* application);
static void main_window_on_entry_icon_press (MainWindow* self,
                                      GtkEntry* entry);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static void __lambda4_ (Block2Data* _data2_);
static void ___lambda4__gtk_color_selection_color_changed (GtkColorSelection* _sender,
                                                    gpointer self);
static void main_window_on_entry_changed (MainWindow* self);
static void main_window_style_results_pane (MainWindow* self,
                                     const gchar* fg_color,
                                     const gchar* bg_color);
static gdouble main_window_get_luminance (MainWindow* self,
                                   GdkRGBA* color);
void grade_label_set_pass (GradeLabel* self,
                           gboolean value);
static gdouble main_window_sanitize_color (MainWindow* self,
                                    gdouble color);
static gboolean main_window_real_configure_event (GtkWidget* base,
                                           GdkEventConfigure* event);
static GObject * main_window_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties);
GradeLabel* grade_label_new (const gchar* level);
GradeLabel* grade_label_construct (GType object_type,
                                   const gchar* level);
static void _main_window___lambda5_ (MainWindow* self,
                              GtkEntryIconPosition pos,
                              GdkEventButton* event);
static void __main_window___lambda5__gtk_entry_icon_press (GtkEntry* _sender,
                                                    GtkEntryIconPosition icon_pos,
                                                    GdkEventButton* event,
                                                    gpointer self);
static void _main_window___lambda6_ (MainWindow* self);
static void __main_window___lambda6__gtk_editable_changed (GtkEditable* _sender,
                                                    gpointer self);
static void _main_window___lambda7_ (MainWindow* self,
                              GtkEntryIconPosition pos,
                              GdkEventButton* event);
static void __main_window___lambda7__gtk_entry_icon_press (GtkEntry* _sender,
                                                    GtkEntryIconPosition icon_pos,
                                                    GdkEventButton* event,
                                                    gpointer self);
static void _main_window___lambda8_ (MainWindow* self);
static void __main_window___lambda8__gtk_editable_changed (GtkEditable* _sender,
                                                    gpointer self);
static void main_window_finalize (GObject * obj);

static inline gpointer
main_window_get_instance_private (MainWindow* self)
{
	return G_STRUCT_MEMBER_P (self, MainWindow_private_offset);
}

MainWindow*
main_window_construct (GType object_type,
                       GtkApplication* application)
{
	MainWindow * self = NULL;
#line 42 "../src/MainWindow.vala"
	g_return_val_if_fail (application != NULL, NULL);
#line 43 "../src/MainWindow.vala"
	self = (MainWindow*) g_object_new (object_type, "application", application, "height-request", 500, "icon-name", "com.github.danrabbit.harvey", "resizable", FALSE, "title", _ ("Harvey"), "width-request", 700, NULL);
#line 42 "../src/MainWindow.vala"
	return self;
#line 167 "MainWindow.c"
}

MainWindow*
main_window_new (GtkApplication* application)
{
#line 42 "../src/MainWindow.vala"
	return main_window_construct (TYPE_MAIN_WINDOW, application);
#line 175 "MainWindow.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 166 "../src/MainWindow.vala"
	return self ? g_object_ref (self) : NULL;
#line 183 "MainWindow.c"
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 166 "../src/MainWindow.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 166 "../src/MainWindow.vala"
	return _data2_;
#line 193 "MainWindow.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 166 "../src/MainWindow.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 203 "MainWindow.c"
		MainWindow* self;
#line 166 "../src/MainWindow.vala"
		self = _data2_->self;
#line 166 "../src/MainWindow.vala"
		_g_object_unref0 (_data2_->entry);
#line 166 "../src/MainWindow.vala"
		_g_object_unref0 (self);
#line 166 "../src/MainWindow.vala"
		g_slice_free (Block2Data, _data2_);
#line 213 "MainWindow.c"
	}
}

static void
__lambda4_ (Block2Data* _data2_)
{
	MainWindow* self;
	gboolean _tmp0_ = FALSE;
	GtkEntry* _tmp1_;
	GtkColorSelection* _tmp12_;
	GdkRGBA _tmp13_ = {0};
	GdkRGBA _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
#line 176 "../src/MainWindow.vala"
	self = _data2_->self;
#line 177 "../src/MainWindow.vala"
	_tmp1_ = self->priv->fg_entry;
#line 177 "../src/MainWindow.vala"
	if (_data2_->entry == _tmp1_) {
#line 234 "MainWindow.c"
		const gchar* _tmp2_;
#line 177 "../src/MainWindow.vala"
		_tmp2_ = self->priv->prev_foreground_entry;
#line 177 "../src/MainWindow.vala"
		_tmp0_ = _tmp2_ == NULL;
#line 240 "MainWindow.c"
	} else {
#line 177 "../src/MainWindow.vala"
		_tmp0_ = FALSE;
#line 244 "MainWindow.c"
	}
#line 177 "../src/MainWindow.vala"
	if (_tmp0_) {
#line 248 "MainWindow.c"
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
#line 178 "../src/MainWindow.vala"
		_tmp3_ = gtk_entry_get_text (_data2_->entry);
#line 178 "../src/MainWindow.vala"
		_tmp4_ = _tmp3_;
#line 178 "../src/MainWindow.vala"
		_tmp5_ = g_strdup (_tmp4_);
#line 178 "../src/MainWindow.vala"
		_g_free0 (self->priv->prev_foreground_entry);
#line 178 "../src/MainWindow.vala"
		self->priv->prev_foreground_entry = _tmp5_;
#line 262 "MainWindow.c"
	} else {
		gboolean _tmp6_ = FALSE;
		GtkEntry* _tmp7_;
#line 179 "../src/MainWindow.vala"
		_tmp7_ = self->priv->bg_entry;
#line 179 "../src/MainWindow.vala"
		if (_data2_->entry == _tmp7_) {
#line 270 "MainWindow.c"
			const gchar* _tmp8_;
#line 179 "../src/MainWindow.vala"
			_tmp8_ = self->priv->prev_background_entry;
#line 179 "../src/MainWindow.vala"
			_tmp6_ = _tmp8_ == NULL;
#line 276 "MainWindow.c"
		} else {
#line 179 "../src/MainWindow.vala"
			_tmp6_ = FALSE;
#line 280 "MainWindow.c"
		}
#line 179 "../src/MainWindow.vala"
		if (_tmp6_) {
#line 284 "MainWindow.c"
			const gchar* _tmp9_;
			const gchar* _tmp10_;
			gchar* _tmp11_;
#line 180 "../src/MainWindow.vala"
			_tmp9_ = gtk_entry_get_text (_data2_->entry);
#line 180 "../src/MainWindow.vala"
			_tmp10_ = _tmp9_;
#line 180 "../src/MainWindow.vala"
			_tmp11_ = g_strdup (_tmp10_);
#line 180 "../src/MainWindow.vala"
			_g_free0 (self->priv->prev_background_entry);
#line 180 "../src/MainWindow.vala"
			self->priv->prev_background_entry = _tmp11_;
#line 298 "MainWindow.c"
		}
	}
#line 183 "../src/MainWindow.vala"
	_tmp12_ = _data2_->widget;
#line 183 "../src/MainWindow.vala"
	gtk_color_selection_get_current_rgba (_tmp12_, &_tmp13_);
#line 183 "../src/MainWindow.vala"
	_tmp14_ = _tmp13_;
#line 183 "../src/MainWindow.vala"
	_tmp15_ = gdk_rgba_to_string (&_tmp14_);
#line 183 "../src/MainWindow.vala"
	_tmp16_ = _tmp15_;
#line 183 "../src/MainWindow.vala"
	gtk_entry_set_text (_data2_->entry, _tmp16_);
#line 183 "../src/MainWindow.vala"
	_g_free0 (_tmp16_);
#line 315 "MainWindow.c"
}

static void
___lambda4__gtk_color_selection_color_changed (GtkColorSelection* _sender,
                                               gpointer self)
{
#line 176 "../src/MainWindow.vala"
	__lambda4_ (self);
#line 324 "MainWindow.c"
}

static void
main_window_on_entry_icon_press (MainWindow* self,
                                 GtkEntry* entry)
{
	Block2Data* _data2_;
	GtkEntry* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GtkColorSelectionDialog* dialog = NULL;
	GtkColorSelectionDialog* _tmp3_;
	GtkColorSelectionDialog* _tmp4_;
	GtkColorSelectionDialog* _tmp5_;
	GtkColorSelectionDialog* _tmp6_;
	GtkColorSelection* _tmp7_;
	GtkColorSelection* _tmp8_;
	GdkRGBA _tmp9_;
	GtkColorSelection* _tmp10_;
	GtkColorSelectionDialog* _tmp11_;
	GtkColorSelectionDialog* _tmp23_;
#line 166 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 166 "../src/MainWindow.vala"
	g_return_if_fail (entry != NULL);
#line 166 "../src/MainWindow.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 166 "../src/MainWindow.vala"
	_data2_->_ref_count_ = 1;
#line 166 "../src/MainWindow.vala"
	_data2_->self = g_object_ref (self);
#line 166 "../src/MainWindow.vala"
	_tmp0_ = _g_object_ref0 (entry);
#line 166 "../src/MainWindow.vala"
	_g_object_unref0 (_data2_->entry);
#line 166 "../src/MainWindow.vala"
	_data2_->entry = _tmp0_;
#line 167 "../src/MainWindow.vala"
	_tmp1_ = gtk_entry_get_text (_data2_->entry);
#line 167 "../src/MainWindow.vala"
	_tmp2_ = _tmp1_;
#line 167 "../src/MainWindow.vala"
	gdk_rgba_parse (&self->priv->gdk_color, _tmp2_);
#line 169 "../src/MainWindow.vala"
	_tmp3_ = (GtkColorSelectionDialog*) gtk_color_selection_dialog_new ("");
#line 169 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp3_);
#line 169 "../src/MainWindow.vala"
	dialog = _tmp3_;
#line 170 "../src/MainWindow.vala"
	_tmp4_ = dialog;
#line 170 "../src/MainWindow.vala"
	gtk_window_set_deletable ((GtkWindow*) _tmp4_, FALSE);
#line 171 "../src/MainWindow.vala"
	_tmp5_ = dialog;
#line 171 "../src/MainWindow.vala"
	gtk_window_set_transient_for ((GtkWindow*) _tmp5_, (GtkWindow*) self);
#line 173 "../src/MainWindow.vala"
	_tmp6_ = dialog;
#line 173 "../src/MainWindow.vala"
	_tmp7_ = gtk_color_selection_dialog_get_color_selection (_tmp6_);
#line 173 "../src/MainWindow.vala"
	_data2_->widget = _tmp7_;
#line 174 "../src/MainWindow.vala"
	_tmp8_ = _data2_->widget;
#line 174 "../src/MainWindow.vala"
	_tmp9_ = self->priv->gdk_color;
#line 174 "../src/MainWindow.vala"
	gtk_color_selection_set_current_rgba (_tmp8_, &_tmp9_);
#line 176 "../src/MainWindow.vala"
	_tmp10_ = _data2_->widget;
#line 176 "../src/MainWindow.vala"
	g_signal_connect_data (_tmp10_, "color-changed", (GCallback) ___lambda4__gtk_color_selection_color_changed, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
#line 186 "../src/MainWindow.vala"
	_tmp11_ = dialog;
#line 186 "../src/MainWindow.vala"
	if (gtk_dialog_run ((GtkDialog*) _tmp11_) == ((gint) GTK_RESPONSE_OK)) {
#line 402 "MainWindow.c"
		GtkColorSelection* _tmp12_;
		GdkRGBA _tmp13_ = {0};
		GdkRGBA _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
#line 187 "../src/MainWindow.vala"
		_tmp12_ = _data2_->widget;
#line 187 "../src/MainWindow.vala"
		gtk_color_selection_get_current_rgba (_tmp12_, &_tmp13_);
#line 187 "../src/MainWindow.vala"
		_tmp14_ = _tmp13_;
#line 187 "../src/MainWindow.vala"
		_tmp15_ = gdk_rgba_to_string (&_tmp14_);
#line 187 "../src/MainWindow.vala"
		_tmp16_ = _tmp15_;
#line 187 "../src/MainWindow.vala"
		gtk_entry_set_text (_data2_->entry, _tmp16_);
#line 187 "../src/MainWindow.vala"
		_g_free0 (_tmp16_);
#line 422 "MainWindow.c"
	} else {
		const gchar* _tmp17_;
		const gchar* _tmp20_;
#line 189 "../src/MainWindow.vala"
		_tmp17_ = self->priv->prev_foreground_entry;
#line 189 "../src/MainWindow.vala"
		if (_tmp17_ != NULL) {
#line 430 "MainWindow.c"
			GtkEntry* _tmp18_;
			const gchar* _tmp19_;
#line 190 "../src/MainWindow.vala"
			_tmp18_ = self->priv->fg_entry;
#line 190 "../src/MainWindow.vala"
			_tmp19_ = self->priv->prev_foreground_entry;
#line 190 "../src/MainWindow.vala"
			gtk_entry_set_text (_tmp18_, _tmp19_);
#line 439 "MainWindow.c"
		}
#line 193 "../src/MainWindow.vala"
		_tmp20_ = self->priv->prev_background_entry;
#line 193 "../src/MainWindow.vala"
		if (_tmp20_ != NULL) {
#line 445 "MainWindow.c"
			GtkEntry* _tmp21_;
			const gchar* _tmp22_;
#line 194 "../src/MainWindow.vala"
			_tmp21_ = self->priv->bg_entry;
#line 194 "../src/MainWindow.vala"
			_tmp22_ = self->priv->prev_background_entry;
#line 194 "../src/MainWindow.vala"
			gtk_entry_set_text (_tmp21_, _tmp22_);
#line 454 "MainWindow.c"
		}
	}
#line 198 "../src/MainWindow.vala"
	_g_free0 (self->priv->prev_foreground_entry);
#line 198 "../src/MainWindow.vala"
	self->priv->prev_foreground_entry = NULL;
#line 199 "../src/MainWindow.vala"
	_g_free0 (self->priv->prev_background_entry);
#line 199 "../src/MainWindow.vala"
	self->priv->prev_background_entry = NULL;
#line 201 "../src/MainWindow.vala"
	_tmp23_ = dialog;
#line 201 "../src/MainWindow.vala"
	g_signal_emit_by_name ((GtkDialog*) _tmp23_, "close");
#line 166 "../src/MainWindow.vala"
	_g_object_unref0 (dialog);
#line 166 "../src/MainWindow.vala"
	block2_data_unref (_data2_);
#line 166 "../src/MainWindow.vala"
	_data2_ = NULL;
#line 475 "MainWindow.c"
}

static void
main_window_on_entry_changed (MainWindow* self)
{
	gboolean _tmp0_ = FALSE;
	GtkEntry* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
#line 204 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 205 "../src/MainWindow.vala"
	_tmp1_ = self->priv->fg_entry;
#line 205 "../src/MainWindow.vala"
	_tmp2_ = gtk_entry_get_text (_tmp1_);
#line 205 "../src/MainWindow.vala"
	_tmp3_ = _tmp2_;
#line 205 "../src/MainWindow.vala"
	_tmp4_ = strlen (_tmp3_);
#line 205 "../src/MainWindow.vala"
	_tmp5_ = _tmp4_;
#line 205 "../src/MainWindow.vala"
	if (_tmp5_ > 2) {
#line 501 "MainWindow.c"
		GtkEntry* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
#line 205 "../src/MainWindow.vala"
		_tmp6_ = self->priv->bg_entry;
#line 205 "../src/MainWindow.vala"
		_tmp7_ = gtk_entry_get_text (_tmp6_);
#line 205 "../src/MainWindow.vala"
		_tmp8_ = _tmp7_;
#line 205 "../src/MainWindow.vala"
		_tmp9_ = strlen (_tmp8_);
#line 205 "../src/MainWindow.vala"
		_tmp10_ = _tmp9_;
#line 205 "../src/MainWindow.vala"
		_tmp0_ = _tmp10_ > 2;
#line 519 "MainWindow.c"
	} else {
#line 205 "../src/MainWindow.vala"
		_tmp0_ = FALSE;
#line 523 "MainWindow.c"
	}
#line 205 "../src/MainWindow.vala"
	if (_tmp0_) {
#line 527 "MainWindow.c"
		GtkEntry* _tmp11_;
		const gchar* _tmp12_;
		const gchar* _tmp13_;
		GtkEntry* _tmp14_;
		const gchar* _tmp15_;
		const gchar* _tmp16_;
#line 206 "../src/MainWindow.vala"
		_tmp11_ = self->priv->fg_entry;
#line 206 "../src/MainWindow.vala"
		_tmp12_ = gtk_entry_get_text (_tmp11_);
#line 206 "../src/MainWindow.vala"
		_tmp13_ = _tmp12_;
#line 206 "../src/MainWindow.vala"
		_tmp14_ = self->priv->bg_entry;
#line 206 "../src/MainWindow.vala"
		_tmp15_ = gtk_entry_get_text (_tmp14_);
#line 206 "../src/MainWindow.vala"
		_tmp16_ = _tmp15_;
#line 206 "../src/MainWindow.vala"
		main_window_style_results_pane (self, _tmp13_, _tmp16_);
#line 548 "MainWindow.c"
	}
}

static void
main_window_style_results_pane (MainWindow* self,
                                const gchar* fg_color,
                                const gchar* bg_color)
{
	GtkCssProvider* provider = NULL;
	GtkCssProvider* _tmp0_;
	GSettings* _tmp9_;
	GtkEntry* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	GSettings* _tmp13_;
	GtkEntry* _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	gdouble pango_fg_luminance = 0.0;
	GdkRGBA _tmp17_;
	gdouble pango_bg_luminance = 0.0;
	GdkRGBA _tmp18_;
	gdouble contrast_ratio = 0.0;
	GtkLabel* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	GError * _inner_error_ = NULL;
#line 210 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 210 "../src/MainWindow.vala"
	g_return_if_fail (fg_color != NULL);
#line 210 "../src/MainWindow.vala"
	g_return_if_fail (bg_color != NULL);
#line 211 "../src/MainWindow.vala"
	_tmp0_ = gtk_css_provider_new ();
#line 211 "../src/MainWindow.vala"
	provider = _tmp0_;
#line 586 "MainWindow.c"
	{
		gchar* colored_css = NULL;
		gchar* _tmp1_;
		GtkCssProvider* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		GdkScreen* _tmp7_;
		GtkCssProvider* _tmp8_;
#line 213 "../src/MainWindow.vala"
		_tmp1_ = g_strdup_printf (MAIN_WINDOW_RESULTS_CSS, fg_color, bg_color);
#line 213 "../src/MainWindow.vala"
		colored_css = _tmp1_;
#line 214 "../src/MainWindow.vala"
		_tmp2_ = provider;
#line 214 "../src/MainWindow.vala"
		_tmp3_ = colored_css;
#line 214 "../src/MainWindow.vala"
		_tmp4_ = colored_css;
#line 214 "../src/MainWindow.vala"
		_tmp5_ = strlen (_tmp4_);
#line 214 "../src/MainWindow.vala"
		_tmp6_ = _tmp5_;
#line 214 "../src/MainWindow.vala"
		gtk_css_provider_load_from_data (_tmp2_, _tmp3_, (gssize) _tmp6_, &_inner_error_);
#line 214 "../src/MainWindow.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 214 "../src/MainWindow.vala"
			_g_free0 (colored_css);
#line 617 "MainWindow.c"
			goto __catch0_g_error;
		}
#line 216 "../src/MainWindow.vala"
		_tmp7_ = gdk_screen_get_default ();
#line 216 "../src/MainWindow.vala"
		_tmp8_ = provider;
#line 216 "../src/MainWindow.vala"
		gtk_style_context_add_provider_for_screen (_tmp7_, (GtkStyleProvider*) _tmp8_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 212 "../src/MainWindow.vala"
		_g_free0 (colored_css);
#line 628 "MainWindow.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
#line 212 "../src/MainWindow.vala"
		e = _inner_error_;
#line 212 "../src/MainWindow.vala"
		_inner_error_ = NULL;
#line 218 "../src/MainWindow.vala"
		_g_error_free0 (e);
#line 218 "../src/MainWindow.vala"
		_g_object_unref0 (provider);
#line 218 "../src/MainWindow.vala"
		return;
#line 644 "MainWindow.c"
	}
	__finally0:
#line 212 "../src/MainWindow.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 212 "../src/MainWindow.vala"
		_g_object_unref0 (provider);
#line 212 "../src/MainWindow.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 212 "../src/MainWindow.vala"
		g_clear_error (&_inner_error_);
#line 212 "../src/MainWindow.vala"
		return;
#line 657 "MainWindow.c"
	}
#line 221 "../src/MainWindow.vala"
	_tmp9_ = harvey_settings;
#line 221 "../src/MainWindow.vala"
	_tmp10_ = self->priv->fg_entry;
#line 221 "../src/MainWindow.vala"
	_tmp11_ = gtk_entry_get_text (_tmp10_);
#line 221 "../src/MainWindow.vala"
	_tmp12_ = _tmp11_;
#line 221 "../src/MainWindow.vala"
	g_settings_set_string (_tmp9_, "fg-color", _tmp12_);
#line 222 "../src/MainWindow.vala"
	_tmp13_ = harvey_settings;
#line 222 "../src/MainWindow.vala"
	_tmp14_ = self->priv->bg_entry;
#line 222 "../src/MainWindow.vala"
	_tmp15_ = gtk_entry_get_text (_tmp14_);
#line 222 "../src/MainWindow.vala"
	_tmp16_ = _tmp15_;
#line 222 "../src/MainWindow.vala"
	g_settings_set_string (_tmp13_, "bg-color", _tmp16_);
#line 224 "../src/MainWindow.vala"
	gdk_rgba_parse (&self->priv->gdk_color, fg_color);
#line 225 "../src/MainWindow.vala"
	_tmp17_ = self->priv->gdk_color;
#line 225 "../src/MainWindow.vala"
	pango_fg_luminance = main_window_get_luminance (self, &_tmp17_);
#line 227 "../src/MainWindow.vala"
	gdk_rgba_parse (&self->priv->gdk_color, bg_color);
#line 228 "../src/MainWindow.vala"
	_tmp18_ = self->priv->gdk_color;
#line 228 "../src/MainWindow.vala"
	pango_bg_luminance = main_window_get_luminance (self, &_tmp18_);
#line 232 "../src/MainWindow.vala"
	if (pango_bg_luminance > pango_fg_luminance) {
#line 233 "../src/MainWindow.vala"
		contrast_ratio = (pango_bg_luminance + 0.05) / (pango_fg_luminance + 0.05);
#line 695 "MainWindow.c"
	} else {
#line 235 "../src/MainWindow.vala"
		contrast_ratio = (pango_fg_luminance + 0.05) / (pango_bg_luminance + 0.05);
#line 699 "MainWindow.c"
	}
#line 238 "../src/MainWindow.vala"
	_tmp19_ = self->priv->results_label;
#line 238 "../src/MainWindow.vala"
	_tmp20_ = g_strdup_printf ("%.1f:1", contrast_ratio);
#line 238 "../src/MainWindow.vala"
	_tmp21_ = _tmp20_;
#line 238 "../src/MainWindow.vala"
	gtk_label_set_label (_tmp19_, _tmp21_);
#line 238 "../src/MainWindow.vala"
	_g_free0 (_tmp21_);
#line 240 "../src/MainWindow.vala"
	if (contrast_ratio >= ((gdouble) 3)) {
#line 713 "MainWindow.c"
		GradeLabel* _tmp22_;
#line 241 "../src/MainWindow.vala"
		_tmp22_ = self->priv->a_level;
#line 241 "../src/MainWindow.vala"
		grade_label_set_pass (_tmp22_, TRUE);
#line 719 "MainWindow.c"
	} else {
		GradeLabel* _tmp23_;
#line 243 "../src/MainWindow.vala"
		_tmp23_ = self->priv->a_level;
#line 243 "../src/MainWindow.vala"
		grade_label_set_pass (_tmp23_, FALSE);
#line 726 "MainWindow.c"
	}
#line 246 "../src/MainWindow.vala"
	if (contrast_ratio >= 4.5) {
#line 730 "MainWindow.c"
		GradeLabel* _tmp24_;
#line 247 "../src/MainWindow.vala"
		_tmp24_ = self->priv->aa_level;
#line 247 "../src/MainWindow.vala"
		grade_label_set_pass (_tmp24_, TRUE);
#line 736 "MainWindow.c"
	} else {
		GradeLabel* _tmp25_;
#line 249 "../src/MainWindow.vala"
		_tmp25_ = self->priv->aa_level;
#line 249 "../src/MainWindow.vala"
		grade_label_set_pass (_tmp25_, FALSE);
#line 743 "MainWindow.c"
	}
#line 252 "../src/MainWindow.vala"
	if (contrast_ratio >= ((gdouble) 7)) {
#line 747 "MainWindow.c"
		GradeLabel* _tmp26_;
#line 253 "../src/MainWindow.vala"
		_tmp26_ = self->priv->aaa_level;
#line 253 "../src/MainWindow.vala"
		grade_label_set_pass (_tmp26_, TRUE);
#line 753 "MainWindow.c"
	} else {
		GradeLabel* _tmp27_;
#line 255 "../src/MainWindow.vala"
		_tmp27_ = self->priv->aaa_level;
#line 255 "../src/MainWindow.vala"
		grade_label_set_pass (_tmp27_, FALSE);
#line 760 "MainWindow.c"
	}
#line 210 "../src/MainWindow.vala"
	_g_object_unref0 (provider);
#line 764 "MainWindow.c"
}

static gdouble
main_window_get_luminance (MainWindow* self,
                           GdkRGBA* color)
{
	gdouble result = 0.0;
	gdouble red = 0.0;
	GdkRGBA _tmp0_;
	gdouble green = 0.0;
	GdkRGBA _tmp1_;
	gdouble blue = 0.0;
	GdkRGBA _tmp2_;
#line 260 "../src/MainWindow.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 260 "../src/MainWindow.vala"
	g_return_val_if_fail (color != NULL, 0.0);
#line 261 "../src/MainWindow.vala"
	_tmp0_ = *color;
#line 261 "../src/MainWindow.vala"
	red = main_window_sanitize_color (self, _tmp0_.red) * 0.2126;
#line 262 "../src/MainWindow.vala"
	_tmp1_ = *color;
#line 262 "../src/MainWindow.vala"
	green = main_window_sanitize_color (self, _tmp1_.green) * 0.7152;
#line 263 "../src/MainWindow.vala"
	_tmp2_ = *color;
#line 263 "../src/MainWindow.vala"
	blue = main_window_sanitize_color (self, _tmp2_.blue) * 0.0722;
#line 265 "../src/MainWindow.vala"
	result = (red + green) + blue;
#line 265 "../src/MainWindow.vala"
	return result;
#line 798 "MainWindow.c"
}

static gdouble
main_window_sanitize_color (MainWindow* self,
                            gdouble color)
{
	gdouble result = 0.0;
#line 268 "../src/MainWindow.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 269 "../src/MainWindow.vala"
	if (color <= 0.03928) {
#line 270 "../src/MainWindow.vala"
		color = color / 12.92;
#line 812 "MainWindow.c"
	} else {
#line 272 "../src/MainWindow.vala"
		color = pow ((color + 0.055) / 1.055, 2.4);
#line 816 "MainWindow.c"
	}
#line 274 "../src/MainWindow.vala"
	result = color;
#line 274 "../src/MainWindow.vala"
	return result;
#line 822 "MainWindow.c"
}

static gboolean
main_window_real_configure_event (GtkWidget* base,
                                  GdkEventConfigure* event)
{
	MainWindow * self;
	gboolean result = FALSE;
	gint root_x = 0;
	gint root_y = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
#line 277 "../src/MainWindow.vala"
	self = (MainWindow*) base;
#line 277 "../src/MainWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 279 "../src/MainWindow.vala"
	gtk_window_get_position ((GtkWindow*) self, &_tmp0_, &_tmp1_);
#line 279 "../src/MainWindow.vala"
	root_x = _tmp0_;
#line 279 "../src/MainWindow.vala"
	root_y = _tmp1_;
#line 280 "../src/MainWindow.vala"
	_tmp2_ = harvey_settings;
#line 280 "../src/MainWindow.vala"
	g_settings_set_int (_tmp2_, "window-x", root_x);
#line 281 "../src/MainWindow.vala"
	_tmp3_ = harvey_settings;
#line 281 "../src/MainWindow.vala"
	g_settings_set_int (_tmp3_, "window-y", root_y);
#line 283 "../src/MainWindow.vala"
	result = GTK_WIDGET_CLASS (main_window_parent_class)->configure_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow), event);
#line 283 "../src/MainWindow.vala"
	return result;
#line 859 "MainWindow.c"
}

static void
_main_window___lambda5_ (MainWindow* self,
                         GtkEntryIconPosition pos,
                         GdkEventButton* event)
{
#line 143 "../src/MainWindow.vala"
	g_return_if_fail (event != NULL);
#line 144 "../src/MainWindow.vala"
	if (pos == GTK_ENTRY_ICON_SECONDARY) {
#line 871 "MainWindow.c"
		GtkEntry* _tmp0_;
#line 145 "../src/MainWindow.vala"
		_tmp0_ = self->priv->fg_entry;
#line 145 "../src/MainWindow.vala"
		main_window_on_entry_icon_press (self, _tmp0_);
#line 877 "MainWindow.c"
	}
}

static void
__main_window___lambda5__gtk_entry_icon_press (GtkEntry* _sender,
                                               GtkEntryIconPosition icon_pos,
                                               GdkEventButton* event,
                                               gpointer self)
{
#line 143 "../src/MainWindow.vala"
	_main_window___lambda5_ ((MainWindow*) self, icon_pos, event);
#line 889 "MainWindow.c"
}

static void
_main_window___lambda6_ (MainWindow* self)
{
#line 150 "../src/MainWindow.vala"
	main_window_on_entry_changed (self);
#line 897 "MainWindow.c"
}

static void
__main_window___lambda6__gtk_editable_changed (GtkEditable* _sender,
                                               gpointer self)
{
#line 149 "../src/MainWindow.vala"
	_main_window___lambda6_ ((MainWindow*) self);
#line 906 "MainWindow.c"
}

static void
_main_window___lambda7_ (MainWindow* self,
                         GtkEntryIconPosition pos,
                         GdkEventButton* event)
{
#line 153 "../src/MainWindow.vala"
	g_return_if_fail (event != NULL);
#line 154 "../src/MainWindow.vala"
	if (pos == GTK_ENTRY_ICON_SECONDARY) {
#line 918 "MainWindow.c"
		GtkEntry* _tmp0_;
#line 155 "../src/MainWindow.vala"
		_tmp0_ = self->priv->bg_entry;
#line 155 "../src/MainWindow.vala"
		main_window_on_entry_icon_press (self, _tmp0_);
#line 924 "MainWindow.c"
	}
}

static void
__main_window___lambda7__gtk_entry_icon_press (GtkEntry* _sender,
                                               GtkEntryIconPosition icon_pos,
                                               GdkEventButton* event,
                                               gpointer self)
{
#line 153 "../src/MainWindow.vala"
	_main_window___lambda7_ ((MainWindow*) self, icon_pos, event);
#line 936 "MainWindow.c"
}

static void
_main_window___lambda8_ (MainWindow* self)
{
#line 160 "../src/MainWindow.vala"
	main_window_on_entry_changed (self);
#line 944 "MainWindow.c"
}

static void
__main_window___lambda8__gtk_editable_changed (GtkEditable* _sender,
                                               gpointer self)
{
#line 159 "../src/MainWindow.vala"
	_main_window___lambda8_ ((MainWindow*) self);
#line 953 "MainWindow.c"
}

static GObject *
main_window_constructor (GType type,
                         guint n_construct_properties,
                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MainWindow * self;
	GtkLabel* fg_label = NULL;
	GtkLabel* _tmp0_;
	GtkLabel* _tmp1_;
	GtkStyleContext* _tmp2_;
	GtkLabel* _tmp3_;
	GtkLabel* bg_label = NULL;
	GtkLabel* _tmp4_;
	GtkLabel* _tmp5_;
	GtkStyleContext* _tmp6_;
	GtkLabel* _tmp7_;
	GtkLabel* _tmp8_;
	GtkEntry* _tmp9_;
	GtkEntry* _tmp10_;
	GSettings* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	GtkEntry* _tmp14_;
	GtkEntry* _tmp15_;
	GtkEntry* _tmp16_;
	GtkEntry* _tmp17_;
	GSettings* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	GtkEntry* _tmp21_;
	GtkEntry* _tmp22_;
	GtkGrid* input_grid = NULL;
	GtkGrid* _tmp23_;
	GtkGrid* _tmp24_;
	GtkGrid* _tmp25_;
	GtkGrid* _tmp26_;
	GtkLabel* _tmp27_;
	GtkGrid* _tmp28_;
	GtkEntry* _tmp29_;
	GtkGrid* _tmp30_;
	GtkLabel* _tmp31_;
	GtkGrid* _tmp32_;
	GtkEntry* _tmp33_;
	GtkLabel* _tmp34_;
	GtkLabel* _tmp35_;
	GtkLabel* _tmp36_;
	GtkStyleContext* _tmp37_;
	GtkLabel* _tmp38_;
	GtkLabel* _tmp39_;
	GtkLabel* _tmp40_;
	GradeLabel* _tmp41_;
	GradeLabel* _tmp42_;
	GradeLabel* _tmp43_;
	gchar* _tmp44_;
	gchar* _tmp45_;
	GradeLabel* _tmp46_;
	GradeLabel* _tmp47_;
	GradeLabel* _tmp48_;
	gchar* _tmp49_;
	gchar* _tmp50_;
	GradeLabel* _tmp51_;
	GradeLabel* _tmp52_;
	GradeLabel* _tmp53_;
	gchar* _tmp54_;
	gchar* _tmp55_;
	GtkGrid* results_grid = NULL;
	GtkGrid* _tmp56_;
	GtkGrid* _tmp57_;
	GtkGrid* _tmp58_;
	GtkStyleContext* _tmp59_;
	GtkGrid* _tmp60_;
	GtkLabel* _tmp61_;
	GtkGrid* _tmp62_;
	GradeLabel* _tmp63_;
	GtkGrid* _tmp64_;
	GradeLabel* _tmp65_;
	GtkGrid* _tmp66_;
	GradeLabel* _tmp67_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp68_;
	GtkGrid* _tmp69_;
	GtkGrid* _tmp70_;
	GtkGrid* _tmp71_;
	GtkGrid* _tmp72_;
	GtkHeaderBar* input_header = NULL;
	GtkHeaderBar* _tmp73_;
	GtkHeaderBar* _tmp74_;
	GtkHeaderBar* _tmp75_;
	GtkStyleContext* input_header_context = NULL;
	GtkHeaderBar* _tmp76_;
	GtkStyleContext* _tmp77_;
	GtkStyleContext* _tmp78_;
	GtkStyleContext* _tmp79_;
	GtkStyleContext* _tmp80_;
	GtkStyleContext* _tmp81_;
	GtkStyleContext* _tmp82_;
	GtkHeaderBar* output_header = NULL;
	GtkHeaderBar* _tmp83_;
	GtkHeaderBar* _tmp84_;
	GtkStyleContext* output_header_context = NULL;
	GtkHeaderBar* _tmp85_;
	GtkStyleContext* _tmp86_;
	GtkStyleContext* _tmp87_;
	GtkStyleContext* _tmp88_;
	GtkStyleContext* _tmp89_;
	GtkStyleContext* _tmp90_;
	GtkStyleContext* _tmp91_;
	GtkGrid* header_grid = NULL;
	GtkGrid* _tmp92_;
	GtkGrid* _tmp93_;
	GtkHeaderBar* _tmp94_;
	GtkGrid* _tmp95_;
	GtkHeaderBar* _tmp96_;
	GtkSizeGroup* sizegroup = NULL;
	GtkSizeGroup* _tmp97_;
	GtkSizeGroup* _tmp98_;
	GtkGrid* _tmp99_;
	GtkSizeGroup* _tmp100_;
	GtkHeaderBar* _tmp101_;
	GtkGrid* _tmp102_;
	GtkStyleContext* _tmp103_;
	GtkGrid* _tmp104_;
	GtkEntry* _tmp105_;
	GtkEntry* _tmp106_;
	GtkEntry* _tmp107_;
	GtkEntry* _tmp108_;
	GtkEntry* _tmp109_;
	const gchar* _tmp110_;
	const gchar* _tmp111_;
	GtkEntry* _tmp112_;
	const gchar* _tmp113_;
	const gchar* _tmp114_;
#line 53 "../src/MainWindow.vala"
	parent_class = G_OBJECT_CLASS (main_window_parent_class);
#line 53 "../src/MainWindow.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 53 "../src/MainWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MAIN_WINDOW, MainWindow);
#line 54 "../src/MainWindow.vala"
	_tmp0_ = (GtkLabel*) gtk_label_new (_ ("Foreground Color"));
#line 54 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp0_);
#line 54 "../src/MainWindow.vala"
	fg_label = _tmp0_;
#line 55 "../src/MainWindow.vala"
	_tmp1_ = fg_label;
#line 55 "../src/MainWindow.vala"
	_tmp2_ = gtk_widget_get_style_context ((GtkWidget*) _tmp1_);
#line 55 "../src/MainWindow.vala"
	gtk_style_context_add_class (_tmp2_, "h4");
#line 56 "../src/MainWindow.vala"
	_tmp3_ = fg_label;
#line 56 "../src/MainWindow.vala"
	gtk_label_set_xalign (_tmp3_, (gfloat) 0);
#line 58 "../src/MainWindow.vala"
	_tmp4_ = (GtkLabel*) gtk_label_new (_ ("Background Color"));
#line 58 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp4_);
#line 58 "../src/MainWindow.vala"
	bg_label = _tmp4_;
#line 59 "../src/MainWindow.vala"
	_tmp5_ = bg_label;
#line 59 "../src/MainWindow.vala"
	_tmp6_ = gtk_widget_get_style_context ((GtkWidget*) _tmp5_);
#line 59 "../src/MainWindow.vala"
	gtk_style_context_add_class (_tmp6_, "h4");
#line 60 "../src/MainWindow.vala"
	_tmp7_ = bg_label;
#line 60 "../src/MainWindow.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp7_, 12);
#line 61 "../src/MainWindow.vala"
	_tmp8_ = bg_label;
#line 61 "../src/MainWindow.vala"
	gtk_label_set_xalign (_tmp8_, (gfloat) 0);
#line 63 "../src/MainWindow.vala"
	_tmp9_ = (GtkEntry*) gtk_entry_new ();
#line 63 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp9_);
#line 63 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->fg_entry);
#line 63 "../src/MainWindow.vala"
	self->priv->fg_entry = _tmp9_;
#line 64 "../src/MainWindow.vala"
	_tmp10_ = self->priv->fg_entry;
#line 64 "../src/MainWindow.vala"
	_tmp11_ = harvey_settings;
#line 64 "../src/MainWindow.vala"
	_tmp12_ = g_settings_get_string (_tmp11_, "fg-color");
#line 64 "../src/MainWindow.vala"
	_tmp13_ = _tmp12_;
#line 64 "../src/MainWindow.vala"
	gtk_entry_set_text (_tmp10_, _tmp13_);
#line 64 "../src/MainWindow.vala"
	_g_free0 (_tmp13_);
#line 65 "../src/MainWindow.vala"
	_tmp14_ = self->priv->fg_entry;
#line 65 "../src/MainWindow.vala"
	gtk_entry_set_placeholder_text (_tmp14_, "#333");
#line 66 "../src/MainWindow.vala"
	_tmp15_ = self->priv->fg_entry;
#line 66 "../src/MainWindow.vala"
	gtk_entry_set_icon_from_icon_name (_tmp15_, GTK_ENTRY_ICON_SECONDARY, "media-eq-symbolic");
#line 68 "../src/MainWindow.vala"
	_tmp16_ = (GtkEntry*) gtk_entry_new ();
#line 68 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp16_);
#line 68 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->bg_entry);
#line 68 "../src/MainWindow.vala"
	self->priv->bg_entry = _tmp16_;
#line 69 "../src/MainWindow.vala"
	_tmp17_ = self->priv->bg_entry;
#line 69 "../src/MainWindow.vala"
	_tmp18_ = harvey_settings;
#line 69 "../src/MainWindow.vala"
	_tmp19_ = g_settings_get_string (_tmp18_, "bg-color");
#line 69 "../src/MainWindow.vala"
	_tmp20_ = _tmp19_;
#line 69 "../src/MainWindow.vala"
	gtk_entry_set_text (_tmp17_, _tmp20_);
#line 69 "../src/MainWindow.vala"
	_g_free0 (_tmp20_);
#line 70 "../src/MainWindow.vala"
	_tmp21_ = self->priv->bg_entry;
#line 70 "../src/MainWindow.vala"
	gtk_entry_set_placeholder_text (_tmp21_, "rgb (110, 200, 230)");
#line 71 "../src/MainWindow.vala"
	_tmp22_ = self->priv->bg_entry;
#line 71 "../src/MainWindow.vala"
	gtk_entry_set_icon_from_icon_name (_tmp22_, GTK_ENTRY_ICON_SECONDARY, "media-eq-symbolic");
#line 73 "../src/MainWindow.vala"
	_tmp23_ = (GtkGrid*) gtk_grid_new ();
#line 73 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp23_);
#line 73 "../src/MainWindow.vala"
	input_grid = _tmp23_;
#line 74 "../src/MainWindow.vala"
	_tmp24_ = input_grid;
#line 74 "../src/MainWindow.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp24_, GTK_ORIENTATION_VERTICAL);
#line 75 "../src/MainWindow.vala"
	_tmp25_ = input_grid;
#line 75 "../src/MainWindow.vala"
	g_object_set ((GtkWidget*) _tmp25_, "margin", 12, NULL);
#line 76 "../src/MainWindow.vala"
	_tmp26_ = input_grid;
#line 76 "../src/MainWindow.vala"
	_tmp27_ = fg_label;
#line 76 "../src/MainWindow.vala"
	gtk_container_add ((GtkContainer*) _tmp26_, (GtkWidget*) _tmp27_);
#line 77 "../src/MainWindow.vala"
	_tmp28_ = input_grid;
#line 77 "../src/MainWindow.vala"
	_tmp29_ = self->priv->fg_entry;
#line 77 "../src/MainWindow.vala"
	gtk_container_add ((GtkContainer*) _tmp28_, (GtkWidget*) _tmp29_);
#line 78 "../src/MainWindow.vala"
	_tmp30_ = input_grid;
#line 78 "../src/MainWindow.vala"
	_tmp31_ = bg_label;
#line 78 "../src/MainWindow.vala"
	gtk_container_add ((GtkContainer*) _tmp30_, (GtkWidget*) _tmp31_);
#line 79 "../src/MainWindow.vala"
	_tmp32_ = input_grid;
#line 79 "../src/MainWindow.vala"
	_tmp33_ = self->priv->bg_entry;
#line 79 "../src/MainWindow.vala"
	gtk_container_add ((GtkContainer*) _tmp32_, (GtkWidget*) _tmp33_);
#line 81 "../src/MainWindow.vala"
	_tmp34_ = (GtkLabel*) gtk_label_new ("12:1");
#line 81 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp34_);
#line 81 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->results_label);
#line 81 "../src/MainWindow.vala"
	self->priv->results_label = _tmp34_;
#line 82 "../src/MainWindow.vala"
	_tmp35_ = self->priv->results_label;
#line 82 "../src/MainWindow.vala"
	g_object_set ((GtkWidget*) _tmp35_, "expand", TRUE, NULL);
#line 83 "../src/MainWindow.vala"
	_tmp36_ = self->priv->results_label;
#line 83 "../src/MainWindow.vala"
	_tmp37_ = gtk_widget_get_style_context ((GtkWidget*) _tmp36_);
#line 83 "../src/MainWindow.vala"
	gtk_style_context_add_class (_tmp37_, "h1");
#line 84 "../src/MainWindow.vala"
	_tmp38_ = self->priv->results_label;
#line 84 "../src/MainWindow.vala"
	gtk_label_set_selectable (_tmp38_, TRUE);
#line 85 "../src/MainWindow.vala"
	_tmp39_ = self->priv->results_label;
#line 85 "../src/MainWindow.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp39_, GTK_ALIGN_CENTER);
#line 86 "../src/MainWindow.vala"
	_tmp40_ = self->priv->results_label;
#line 86 "../src/MainWindow.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp40_, GTK_ALIGN_CENTER);
#line 88 "../src/MainWindow.vala"
	_tmp41_ = grade_label_new ("WCAG A");
#line 88 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp41_);
#line 88 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->a_level);
#line 88 "../src/MainWindow.vala"
	self->priv->a_level = _tmp41_;
#line 89 "../src/MainWindow.vala"
	_tmp42_ = self->priv->a_level;
#line 89 "../src/MainWindow.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp42_, GTK_ALIGN_CENTER);
#line 90 "../src/MainWindow.vala"
	_tmp43_ = self->priv->a_level;
#line 90 "../src/MainWindow.vala"
	_tmp44_ = g_strdup_printf ("<big><b>%s</b></big>\n%s", _ ("3:1"), _ ("The minimum level recommended by ISO-9241-3 and ANSI-HFES-100-1988 for" \
" standard text and vision"));
#line 90 "../src/MainWindow.vala"
	_tmp45_ = _tmp44_;
#line 90 "../src/MainWindow.vala"
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp43_, _tmp45_);
#line 90 "../src/MainWindow.vala"
	_g_free0 (_tmp45_);
#line 92 "../src/MainWindow.vala"
	_tmp46_ = grade_label_new ("WCAG AA");
#line 92 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp46_);
#line 92 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->aa_level);
#line 92 "../src/MainWindow.vala"
	self->priv->aa_level = _tmp46_;
#line 93 "../src/MainWindow.vala"
	_tmp47_ = self->priv->aa_level;
#line 93 "../src/MainWindow.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp47_, GTK_ALIGN_CENTER);
#line 94 "../src/MainWindow.vala"
	_tmp48_ = self->priv->aa_level;
#line 94 "../src/MainWindow.vala"
	_tmp49_ = g_strdup_printf ("<big><b>%s</b></big>\n%s", _ ("4.5:1"), _ ("Compensates for the loss in contrast that results from moderately low " \
"visual acuity, color deficiencies, or aging."));
#line 94 "../src/MainWindow.vala"
	_tmp50_ = _tmp49_;
#line 94 "../src/MainWindow.vala"
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp48_, _tmp50_);
#line 94 "../src/MainWindow.vala"
	_g_free0 (_tmp50_);
#line 96 "../src/MainWindow.vala"
	_tmp51_ = grade_label_new ("WCAG AAA");
#line 96 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp51_);
#line 96 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->aaa_level);
#line 96 "../src/MainWindow.vala"
	self->priv->aaa_level = _tmp51_;
#line 97 "../src/MainWindow.vala"
	_tmp52_ = self->priv->aaa_level;
#line 97 "../src/MainWindow.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp52_, GTK_ALIGN_CENTER);
#line 98 "../src/MainWindow.vala"
	_tmp53_ = self->priv->aaa_level;
#line 98 "../src/MainWindow.vala"
	_tmp54_ = g_strdup_printf ("<big><b>%s</b></big>\n%s", _ ("7:1"), _ ("Compensates for the loss in contrast sensitivity usually experienced b" \
"y users with about 20/80 vision. People with more than this degree of " \
"vision loss usually use assistive technologies."));
#line 98 "../src/MainWindow.vala"
	_tmp55_ = _tmp54_;
#line 98 "../src/MainWindow.vala"
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp53_, _tmp55_);
#line 98 "../src/MainWindow.vala"
	_g_free0 (_tmp55_);
#line 100 "../src/MainWindow.vala"
	_tmp56_ = (GtkGrid*) gtk_grid_new ();
#line 100 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp56_);
#line 100 "../src/MainWindow.vala"
	results_grid = _tmp56_;
#line 101 "../src/MainWindow.vala"
	_tmp57_ = results_grid;
#line 101 "../src/MainWindow.vala"
	gtk_grid_set_row_spacing (_tmp57_, 12);
#line 102 "../src/MainWindow.vala"
	_tmp58_ = results_grid;
#line 102 "../src/MainWindow.vala"
	_tmp59_ = gtk_widget_get_style_context ((GtkWidget*) _tmp58_);
#line 102 "../src/MainWindow.vala"
	gtk_style_context_add_class (_tmp59_, "results");
#line 103 "../src/MainWindow.vala"
	_tmp60_ = results_grid;
#line 103 "../src/MainWindow.vala"
	_tmp61_ = self->priv->results_label;
#line 103 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp60_, (GtkWidget*) _tmp61_, 0, 0, 3, 1);
#line 104 "../src/MainWindow.vala"
	_tmp62_ = results_grid;
#line 104 "../src/MainWindow.vala"
	_tmp63_ = self->priv->a_level;
#line 104 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp62_, (GtkWidget*) _tmp63_, 0, 1, 1, 1);
#line 105 "../src/MainWindow.vala"
	_tmp64_ = results_grid;
#line 105 "../src/MainWindow.vala"
	_tmp65_ = self->priv->aa_level;
#line 105 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp64_, (GtkWidget*) _tmp65_, 1, 1, 1, 1);
#line 106 "../src/MainWindow.vala"
	_tmp66_ = results_grid;
#line 106 "../src/MainWindow.vala"
	_tmp67_ = self->priv->aaa_level;
#line 106 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp66_, (GtkWidget*) _tmp67_, 2, 1, 1, 1);
#line 108 "../src/MainWindow.vala"
	_tmp68_ = (GtkGrid*) gtk_grid_new ();
#line 108 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp68_);
#line 108 "../src/MainWindow.vala"
	grid = _tmp68_;
#line 109 "../src/MainWindow.vala"
	_tmp69_ = grid;
#line 109 "../src/MainWindow.vala"
	_tmp70_ = input_grid;
#line 109 "../src/MainWindow.vala"
	gtk_container_add ((GtkContainer*) _tmp69_, (GtkWidget*) _tmp70_);
#line 110 "../src/MainWindow.vala"
	_tmp71_ = grid;
#line 110 "../src/MainWindow.vala"
	_tmp72_ = results_grid;
#line 110 "../src/MainWindow.vala"
	gtk_container_add ((GtkContainer*) _tmp71_, (GtkWidget*) _tmp72_);
#line 112 "../src/MainWindow.vala"
	_tmp73_ = (GtkHeaderBar*) gtk_header_bar_new ();
#line 112 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp73_);
#line 112 "../src/MainWindow.vala"
	input_header = _tmp73_;
#line 113 "../src/MainWindow.vala"
	_tmp74_ = input_header;
#line 113 "../src/MainWindow.vala"
	gtk_header_bar_set_decoration_layout (_tmp74_, "close:");
#line 114 "../src/MainWindow.vala"
	_tmp75_ = input_header;
#line 114 "../src/MainWindow.vala"
	gtk_header_bar_set_show_close_button (_tmp75_, TRUE);
#line 116 "../src/MainWindow.vala"
	_tmp76_ = input_header;
#line 116 "../src/MainWindow.vala"
	_tmp77_ = gtk_widget_get_style_context ((GtkWidget*) _tmp76_);
#line 116 "../src/MainWindow.vala"
	_tmp78_ = _g_object_ref0 (_tmp77_);
#line 116 "../src/MainWindow.vala"
	input_header_context = _tmp78_;
#line 117 "../src/MainWindow.vala"
	_tmp79_ = input_header_context;
#line 117 "../src/MainWindow.vala"
	gtk_style_context_add_class (_tmp79_, "input-header");
#line 118 "../src/MainWindow.vala"
	_tmp80_ = input_header_context;
#line 118 "../src/MainWindow.vala"
	gtk_style_context_add_class (_tmp80_, "titlebar");
#line 119 "../src/MainWindow.vala"
	_tmp81_ = input_header_context;
#line 119 "../src/MainWindow.vala"
	gtk_style_context_add_class (_tmp81_, "default-decoration");
#line 120 "../src/MainWindow.vala"
	_tmp82_ = input_header_context;
#line 120 "../src/MainWindow.vala"
	gtk_style_context_add_class (_tmp82_, GTK_STYLE_CLASS_FLAT);
#line 122 "../src/MainWindow.vala"
	_tmp83_ = (GtkHeaderBar*) gtk_header_bar_new ();
#line 122 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp83_);
#line 122 "../src/MainWindow.vala"
	output_header = _tmp83_;
#line 123 "../src/MainWindow.vala"
	_tmp84_ = output_header;
#line 123 "../src/MainWindow.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp84_, TRUE);
#line 125 "../src/MainWindow.vala"
	_tmp85_ = output_header;
#line 125 "../src/MainWindow.vala"
	_tmp86_ = gtk_widget_get_style_context ((GtkWidget*) _tmp85_);
#line 125 "../src/MainWindow.vala"
	_tmp87_ = _g_object_ref0 (_tmp86_);
#line 125 "../src/MainWindow.vala"
	output_header_context = _tmp87_;
#line 126 "../src/MainWindow.vala"
	_tmp88_ = output_header_context;
#line 126 "../src/MainWindow.vala"
	gtk_style_context_add_class (_tmp88_, "output-header");
#line 127 "../src/MainWindow.vala"
	_tmp89_ = output_header_context;
#line 127 "../src/MainWindow.vala"
	gtk_style_context_add_class (_tmp89_, "titlebar");
#line 128 "../src/MainWindow.vala"
	_tmp90_ = output_header_context;
#line 128 "../src/MainWindow.vala"
	gtk_style_context_add_class (_tmp90_, "default-decoration");
#line 129 "../src/MainWindow.vala"
	_tmp91_ = output_header_context;
#line 129 "../src/MainWindow.vala"
	gtk_style_context_add_class (_tmp91_, GTK_STYLE_CLASS_FLAT);
#line 131 "../src/MainWindow.vala"
	_tmp92_ = (GtkGrid*) gtk_grid_new ();
#line 131 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp92_);
#line 131 "../src/MainWindow.vala"
	header_grid = _tmp92_;
#line 132 "../src/MainWindow.vala"
	_tmp93_ = header_grid;
#line 132 "../src/MainWindow.vala"
	_tmp94_ = input_header;
#line 132 "../src/MainWindow.vala"
	gtk_container_add ((GtkContainer*) _tmp93_, (GtkWidget*) _tmp94_);
#line 133 "../src/MainWindow.vala"
	_tmp95_ = header_grid;
#line 133 "../src/MainWindow.vala"
	_tmp96_ = output_header;
#line 133 "../src/MainWindow.vala"
	gtk_container_add ((GtkContainer*) _tmp95_, (GtkWidget*) _tmp96_);
#line 135 "../src/MainWindow.vala"
	_tmp97_ = gtk_size_group_new (GTK_SIZE_GROUP_HORIZONTAL);
#line 135 "../src/MainWindow.vala"
	sizegroup = _tmp97_;
#line 136 "../src/MainWindow.vala"
	_tmp98_ = sizegroup;
#line 136 "../src/MainWindow.vala"
	_tmp99_ = input_grid;
#line 136 "../src/MainWindow.vala"
	gtk_size_group_add_widget (_tmp98_, (GtkWidget*) _tmp99_);
#line 137 "../src/MainWindow.vala"
	_tmp100_ = sizegroup;
#line 137 "../src/MainWindow.vala"
	_tmp101_ = input_header;
#line 137 "../src/MainWindow.vala"
	gtk_size_group_add_widget (_tmp100_, (GtkWidget*) _tmp101_);
#line 139 "../src/MainWindow.vala"
	_tmp102_ = grid;
#line 139 "../src/MainWindow.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp102_);
#line 140 "../src/MainWindow.vala"
	_tmp103_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 140 "../src/MainWindow.vala"
	gtk_style_context_add_class (_tmp103_, "rounded");
#line 141 "../src/MainWindow.vala"
	_tmp104_ = header_grid;
#line 141 "../src/MainWindow.vala"
	gtk_window_set_titlebar ((GtkWindow*) self, (GtkWidget*) _tmp104_);
#line 143 "../src/MainWindow.vala"
	_tmp105_ = self->priv->fg_entry;
#line 143 "../src/MainWindow.vala"
	g_signal_connect_object (_tmp105_, "icon-press", (GCallback) __main_window___lambda5__gtk_entry_icon_press, self, 0);
#line 149 "../src/MainWindow.vala"
	_tmp106_ = self->priv->fg_entry;
#line 149 "../src/MainWindow.vala"
	g_signal_connect_object ((GtkEditable*) _tmp106_, "changed", (GCallback) __main_window___lambda6__gtk_editable_changed, self, 0);
#line 153 "../src/MainWindow.vala"
	_tmp107_ = self->priv->bg_entry;
#line 153 "../src/MainWindow.vala"
	g_signal_connect_object (_tmp107_, "icon-press", (GCallback) __main_window___lambda7__gtk_entry_icon_press, self, 0);
#line 159 "../src/MainWindow.vala"
	_tmp108_ = self->priv->bg_entry;
#line 159 "../src/MainWindow.vala"
	g_signal_connect_object ((GtkEditable*) _tmp108_, "changed", (GCallback) __main_window___lambda8__gtk_editable_changed, self, 0);
#line 163 "../src/MainWindow.vala"
	_tmp109_ = self->priv->fg_entry;
#line 163 "../src/MainWindow.vala"
	_tmp110_ = gtk_entry_get_text (_tmp109_);
#line 163 "../src/MainWindow.vala"
	_tmp111_ = _tmp110_;
#line 163 "../src/MainWindow.vala"
	_tmp112_ = self->priv->bg_entry;
#line 163 "../src/MainWindow.vala"
	_tmp113_ = gtk_entry_get_text (_tmp112_);
#line 163 "../src/MainWindow.vala"
	_tmp114_ = _tmp113_;
#line 163 "../src/MainWindow.vala"
	main_window_style_results_pane (self, _tmp111_, _tmp114_);
#line 53 "../src/MainWindow.vala"
	_g_object_unref0 (sizegroup);
#line 53 "../src/MainWindow.vala"
	_g_object_unref0 (header_grid);
#line 53 "../src/MainWindow.vala"
	_g_object_unref0 (output_header_context);
#line 53 "../src/MainWindow.vala"
	_g_object_unref0 (output_header);
#line 53 "../src/MainWindow.vala"
	_g_object_unref0 (input_header_context);
#line 53 "../src/MainWindow.vala"
	_g_object_unref0 (input_header);
#line 53 "../src/MainWindow.vala"
	_g_object_unref0 (grid);
#line 53 "../src/MainWindow.vala"
	_g_object_unref0 (results_grid);
#line 53 "../src/MainWindow.vala"
	_g_object_unref0 (input_grid);
#line 53 "../src/MainWindow.vala"
	_g_object_unref0 (bg_label);
#line 53 "../src/MainWindow.vala"
	_g_object_unref0 (fg_label);
#line 53 "../src/MainWindow.vala"
	return obj;
#line 1552 "MainWindow.c"
}

static void
main_window_class_init (MainWindowClass * klass,
                        gpointer klass_data)
{
#line 20 "../src/MainWindow.vala"
	main_window_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/MainWindow.vala"
	g_type_class_adjust_private_offset (klass, &MainWindow_private_offset);
#line 20 "../src/MainWindow.vala"
	((GtkWidgetClass *) klass)->configure_event = (gboolean (*) (GtkWidget*, GdkEventConfigure*)) main_window_real_configure_event;
#line 20 "../src/MainWindow.vala"
	G_OBJECT_CLASS (klass)->constructor = main_window_constructor;
#line 20 "../src/MainWindow.vala"
	G_OBJECT_CLASS (klass)->finalize = main_window_finalize;
#line 1569 "MainWindow.c"
}

static void
main_window_instance_init (MainWindow * self,
                           gpointer klass)
{
#line 20 "../src/MainWindow.vala"
	self->priv = main_window_get_instance_private (self);
#line 39 "../src/MainWindow.vala"
	self->priv->prev_foreground_entry = NULL;
#line 40 "../src/MainWindow.vala"
	self->priv->prev_background_entry = NULL;
#line 1582 "MainWindow.c"
}

static void
main_window_finalize (GObject * obj)
{
	MainWindow * self;
#line 20 "../src/MainWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MAIN_WINDOW, MainWindow);
#line 32 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->bg_entry);
#line 33 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->fg_entry);
#line 34 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->results_label);
#line 35 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->a_level);
#line 36 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->aa_level);
#line 37 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->aaa_level);
#line 39 "../src/MainWindow.vala"
	_g_free0 (self->priv->prev_foreground_entry);
#line 40 "../src/MainWindow.vala"
	_g_free0 (self->priv->prev_background_entry);
#line 20 "../src/MainWindow.vala"
	G_OBJECT_CLASS (main_window_parent_class)->finalize (obj);
#line 1609 "MainWindow.c"
}

GType
main_window_get_type (void)
{
	static volatile gsize main_window_type_id__volatile = 0;
	if (g_once_init_enter (&main_window_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MainWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) main_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MainWindow), 0, (GInstanceInitFunc) main_window_instance_init, NULL };
		GType main_window_type_id;
		main_window_type_id = g_type_register_static (gtk_window_get_type (), "MainWindow", &g_define_type_info, 0);
		MainWindow_private_offset = g_type_add_instance_private (main_window_type_id, sizeof (MainWindowPrivate));
		g_once_init_leave (&main_window_type_id__volatile, main_window_type_id);
	}
	return main_window_type_id__volatile;
}

